var browserSync = require("browser-sync").create();
var gulp = require("gulp"),
    clean = require('gulp-clean-css'),
    concat = require("gulp-concat"),
    rename = require('gulp-rename'),
    sass = require('gulp-sass'),
    uglify = require("gulp-uglify");

var css_folder = "css/";
var djs_folder = "dist/js";
var dcss_folder = "dist/css/";

var js_watch = [
    "js/plugins.js",
    "js/main.js",
    "js/adonHelloWorld.js",
    "js/adonMadStuff.js",
    "js/adonStatus.js",
    "js/adonToolBar.js",
];

var sass_watch = [
    "stylesheets/*.scss",
    "stylesheets/**/*.scss",
];

// Compile sass into CSS & auto-inject into browsers
gulp.task("sass", function() {
    return gulp.src("stylesheets/judge.scss")
        .pipe(sass({
            includePaths: sass_watch
        }))
        .pipe(concat("adon.css"))
        .pipe(gulp.dest(css_folder))
        .pipe(rename("adon.min.css"))
        .pipe(clean())
        .pipe(gulp.dest(css_folder))
        .pipe(browserSync.stream())
});

var distro_css = [
    "css/normalize.css",
    "css/main.css",
    "css/adon.css",
];

// Minify css into CSS & auto-inject into browsers
gulp.task("clean", function() {
    return gulp.src(distro_css)
        .pipe(concat("adon.min.css"))
        .pipe(clean())
        .pipe(gulp.dest(dcss_folder))
        .pipe(browserSync.stream())
});

// distribute this addon
gulp.task("minify-js", function() {
    gulp.src(js_watch)
        // .pipe(uglify())
        // .pipe(concat("adon.js"))
        // .pipe(gulp.dest(djs_folder))
        .pipe(browserSync.stream())
});

gulp.task("watch", ["sass", "clean", "minify-js"], function() {
    browserSync.init({
        server: "./"
    });
    gulp.watch(sass_watch, ["sass", "clean"]);
    gulp.watch(sass_watch).on('change', browserSync.reload);
    gulp.watch(js_watch, ["minify-js"]);
    gulp.watch(js_watch).on('change', browserSync.reload);
    gulp.watch(["index.html"]).on('change', browserSync.reload);
});

gulp.task("default", ["sass", "clean", "minify-js", "watch"]);
